// html handler

inherit "../text/handler.pike";

static string tag_title( string tag_name, mapping args, string contents, object foo )
{
  foo->title = contents;
}

// This method may seem internal, but is called from strange places indeed
string get_title( string data )
{
  mapping foo = ([ ]);

  parse_html( data, ([ ]), ([ "title" : tag_title ]), foo );
  return foo->title;
}

object|string|mapping view( object fd, mapping headers, object id,
			    mapping md, object vcfile )
{
  object fd = ::view( fd, headers, id, md, vcfile );
  string txt = fd->read(0x7fffffff);
  string tmpl = md->template;
  if(tmpl && (tmpl != "__0"))
    txt = "<template name='"+replace(tmpl,"'","'\"'\"'")+"'>"+txt+"</template>";
  id->misc->metadata = md;
  if(!id->misc->defines)
    id->misc->defines = ([]);

  mapping res = http_rxml_answer(txt, id, fd, headers["content-type"]);

  m_delete(headers, "content-type");

  res->extra_heads = headers + res->extra_heads;

  return(res);
}

int upload( object vcfile, object id, object vcfd )
{
  string title = vcfd->md->title;

  vcfd->fd->reopen ("r");
  string data = vcfd->fd->read();

  if (!title || title == "")
  {
    title = get_title( data );
    if (title && title != "") vcfd->md += (["title": title]);
  }

  data = replace( data, "\r\n", "\n" );
  data = replace( data, "\r", "\n" );

  vcfd->fd->reopen ("cwt");
  vcfd->fd->write (data);

  return 1;
}
