inherit "wizard";

inherit "../default/handler.pike";

string folder(int num, object id, int unfolded)
{
  return "<input type=image name="+(unfolded?"fold":"unfold")+num+" src="+
    id->misc->img_url+
    (unfolded? "fold.gif":"unfold.gif")+" alt='"+
    (unfolded? "\/":"--")+"' border=0>";
}


string icons(int num, object id)
{
  string res="";
  if(sizeof(id->variables->items)>1)
  {
    if(num == 0)
      res +=
	"<input type=image src=\""+id->misc->img_url+"movedown.gif\""
	" width=15 height=20 border=0 name=down_"+num+" alt='Move down'>";
    if(num > 0 && num < sizeof(id->variables->items)-1)
      res +=
	"<input type=image src=\""+id->misc->img_url+"moveupordown.gif\""
	" width=15 height=20 border=0 name=upordown_"+num+" alt='Move'>";
    if(num == sizeof(id->variables->items)-1)
      res +=
	"<input type=image src=\""+id->misc->img_url+"moveup.gif\""
	" width=15 height=20 border=0 name=up_"+num+" alt='Move up'>";
  }
  else
    res +=
      "<img src=/internal-roxen-unit alt='' width=15 height=20 border=0>";
  return
    res+
     " <input type=image src=\""+id->misc->img_url+"removed.gif\""
      " width=15 height=20 border=0 name=delete_"+num+">";
}

string mi_view(int num, object id)
    {
  string url=id->variables->items[num]->url||"";
  return
    "<tr><td>"+folder(num,id,0)+"</td><td nowrap>"+
    "<a href="+url+">"+url+"</a>&nbsp;</td><td nowrap>"+
    html_encode_string(id->variables->items[num]->title||"")+"&nbsp;</td>"+
    "<td nowrap>"+
    icons(num,id)+
    "</td></tr>";
}

string mi_edit(int num, object id)
{
  string url="<var size=20 name=url_"+num+" type=string>";
  string buttons=icons(num,id);
  return
    "<tr><td>"+folder(num,id,1)+"</td><td nowrap>"+
    url+"</td><td nowrap>"+
    "<var size=18 name=title_"+num+" type=string></td><td nowrap>"+
    buttons+"</td></tr>";
}

array parse_items(object id)
{
  int i;
  string t;
  array items=id->variables->items;
  for(i=0;i<sizeof(items);i++)
  {
    foreach( ({"",".x",".y"}), string foo)
      foreach( ({"","un"}), string gazonk)
	if(id->variables[gazonk+"fold"+i+foo])
	  foreach( ({"",".x",".y"}), string bar)
	  {
	    items[i]->_unfoldp=(gazonk=="un");
	    m_delete(id->variables,gazonk+"fold"+i+bar);
	  }
    if(t=id->variables["title_"+i]) items[i]->title=t;
    if(t=id->variables["url_"+i])   items[i]->url=t;
  }
  return items;
}

string parse_item(string tag, mapping args,
			 string contents, mapping items)
{
  function parseit=lambda(string tag, mapping args,
			  string contents, mapping meta)
		   {
		     meta[tag]=html_decode_string(contents);
		   };
  
  mapping res=([]);
  parse_html(contents, ([]),
	     ([
	       "url":parseit,
	       "title":parseit,
	     ]),
	     res);
  items->items=items->items+({res});
  return 0;
}

array parse_menu(string itemtext)
{
  mapping items = ([ "items":({ }) ]);
  parse_html(itemtext, ([]), (["mi":parse_item]),
	     items);
  return items->items;
}

string compile_menu(array items)
{
  string res="";
  foreach(items, mapping item)
  {
    res+="<mi>\n";
    foreach(sort(indices(item)), string itemstr)
      if(itemstr[0..0]!="_")
	res+=sprintf("  <%s>%s</%s>\n",itemstr,
		     html_encode_string((string)item[itemstr]), itemstr);
    res+="</mi>\n";
  }
  return res;
}


string edit(object fd, object id )
{
  string s="<font size=+1>Click a folder icon to edit a line.</font><p>";
  array items=({ });
  if(!id->variables->items)
    items=id->variables->items=parse_menu(fd->read());
  else
    items=id->variables->items;
  int num_lines=sizeof(items);

  int i;
  string t;
  // Parse id->variables
  items=parse_items(id);
  for(i=0;i<num_lines+1;i++)
  {
    if(id->variables["insert_"+i])
      items=items[..i]+({ (["_unfoldp":1,
			    "url":"",
			    "title":"", ]) })+items[i+1..];
    if(id->variables["delete_"+i+".x"])
      items=items[..i-1]+items[i+1..];
    if((id->variables["up_"+i+".x"] ||
	(id->variables["upordown_"+i+".y"] &&
	 (int)id->variables["upordown_"+i+".y"]<=10))
       && i>0)
    {
      array temp=items[i-1];
      items[i-1]=items[i];
      items[i]=temp;
    }
    if((id->variables["down_"+i+".x"] ||
	(id->variables["upordown_"+i+".y"] &&
	 (int)id->variables["upordown_"+i+".y"]>10))
       && i<num_lines-1)
    {
      array temp=items[i+1];
      items[i+1]=items[i];
      items[i]=temp;
    }
    foreach(({"insert_","delete_","up_","down_","upordown_"}), string foo)
      foreach(({"", ".x", ".y"}), string bar)
	m_delete(id->variables,foo+i+bar);
  }

  if(sizeof(items)==0 && !id->variables->inited)
  {
    items+=({ ([ "_unfoldp":1,
		 "url":"",
		 "title":"" ]) });
  }

  // Put the data in items into id->variables
  for(i=0;i<sizeof(items);i++)
  {
    id->variables["title_"+i]=items[i]->title;
    id->variables["url_"+i]=items[i]->url;
  }
  
  id->variables->items=items;
  string a="";
  for(i=0;i<sizeof(items);i++)
    if(items[i]->_unfoldp)
      a+=mi_edit(i,id);
    else
      a+=mi_view(i,id);
  s+="<table bgcolor=#dee1ff cellspacing=0 cellpadding=2 width=80%>"
    "<tr bgcolor=#eeeeee><td></td><td><b>URL</b></td><td><b>Title</b></td>"
    "<td><b>Actions</b></td></tr>";
  s+=a;
  s+=
    "</table><input type=hidden name=inited value='1'>"
    "<input type=submit name=insert_"+num_lines+" value='New row'>";
  
  id->variables->items=items;
  return s;
}

mapping edit_done(object fd,object id)
{
  if(fd)
  {
    array items=parse_items(id);
    fd->write(compile_menu(items));
  }
}

string preview(object vcfile, object id)
{
  object|mapping vcfiledata=vcfile->view(id);
  if(mappingp(vcfiledata))
    return "";
  function desc=lambda(mapping row)
    {
      return ({ "<a href='"+row->url+"'>"+html_encode_string(row->url)+
		"</a>", html_encode_string(row->title) });
    };
  return
    html_table( ({ "URL", "Title"}),
		Array.map(parse_menu(vcfiledata->fd->read()),desc));
}
  

// // This is obselete:
//
// string handle_conflict( object vcfile, object id, array conflicts )
// {
// #if 0
//   werror(sprintf("Conflicts: %O\n",Array.transpose(conflicts[1])));
// #endif
//   object workarea = id->misc->workarea;
//   string res="";
//   function desc=lambda(mapping row)
//     {
//       return ({ "<a href='"+row->url+"'>"+row->url+
// 		"</a>", html_encode_string(row->title),
// 		html_encode_string(row->status) });
//     };
//   res+="<table cellpadding=15><tr><td valign=top>"
//     " <var type=radio value=local name=what> <b>Local version:</b><br>";
//   res+=html_table( ({ "URL", "Title", "Status line"}),
// 		   Array.map(workarea->parse_menu(
// 		     Array.transpose(conflicts[1])[2]*""),desc));
//   res+="</td><td valign=top>"
//     " <var type=radio value=remote name=what> <b>Remote version:</b><br>";
//   res+=html_table( ({ "URL", "Title" }),
// 		   Array.map(workarea->parse_menu(
// 		     Array.transpose(conflicts[1])[4]*""),desc));
//   res+="</td></tr></table>";
//   return res;
// }

// string handle_conflict_done( object f, object id )
// {
//   if (id->variables->what=="local")
//     return id->variables->md_local;
//   else
//     return id->variables->md_remote;
// }

array get_menu( object vcfile, object id )
{
  return parse_menu( vcfile->view( id )->fd->read() );
}


constant noview = 1;
