object parent;

inherit "wizard";

inherit "../text/handler.pike";

string preview(object vcfile, object id)
{
  object|mapping vcfiledata=vcfile->view(id);
  if(mappingp(vcfiledata))
    return "";
  object weblayout=id->conf->get_provider("weblayout_templates");
  if(!weblayout)
    return "<i>No template module found.</i>";
  function desc=lambda(array row)
    {
      return ({ html_encode_string(row[0]),
		html_encode_string(row[1]*", ")
      });
    };

  mapping tags_args=weblayout->get_custom_tags(vcfiledata->fd->read());
  array tags,args;
  tags=indices(tags_args);
  args=values(tags_args);
  sort(tags,args);
  
  return
    html_table( ({ "Tag", "Arguments"}),
		Array.map(Array.transpose(({ tags,args })),
			  desc));
}

mapping viewsource(object vcfile, object id)
{
  object vcres, wlmod;
  string res;

  if (objectp (vcres = vcfile->view (id)))
    res=vcres->fd->read();
  else
    return 0;

  if (!objectp (wlmod = id->conf->get_provider("weblayout_templates")))
    return 0;

  res=
    "<body bgcolor=white text=black>"
    "<h3>Source for "+html_encode_string(vcfile->name(id))+
    "</h3><table width=90% bgcolor=#eeeeee><tr><td>"+
    replace(wlmod->low_view_template(res),
	    // Ho hum...
	    "<font color=\"#ffffaa\">", "<font color=\"#0000aa\">")+
    "</td></tr></table></body>";
  return http_string_answer(res,"text/html");
}

constant noview = 1;

