#include <module.h>

inherit "modules/filesystems/filesystem";

constant cvs_version = "$Id: ac_filesystem.pike,v 1.1 1999/08/23 19:51:24 mast Exp $";

object mac;

array register_module()
{
  return ({ 
    MODULE_LOCATION, 
    "AC Filesystem", 
    "This is a filesystem protected by an AC protection point."
    });
}

void initiate( object conf )
{
  mapping acvar = roxen->query_var ("AC");

  if (!acvar)
    call_out( initiate, 2, conf );
  else
  {
    mac = acvar->ModuleAC (conf, this_object());
    mac->pp_create( "pp", "acfs: $searchpath$" );
  }
}

void start (int when, object conf)
{
  if (conf && !mac)
    initiate( conf );
  ::start();
}

mixed find_file( string f, object id )
{
  if (mac->access_try( "pp", id ) == mac->PERM_NONE)
    return 0;
  else
    return ::find_file( f, id );
}

string real_file( mixed f, object id )
{
  if (mac->access_try( "pp", id ) == mac->PERM_NONE)
    return 0;
  else
    return ::real_file( f, id );
}

array find_dir( string f, object id )
{
  if (mac->access_try( "pp", id ) == mac->PERM_NONE)
    return 0;
  else
    return ::find_dir( f, id );
}

mixed stat_file( mixed f, object id )
{
  if (mac->access_try( "pp", id ) == mac->PERM_NONE)
    return 0;
  else
    return ::stat_file( f, id );
}
