// This is a Roxen module.

string cvs_version = "$Id: acauth_https_only.pike,v 1.2 1999/05/31 23:00:39 mast Exp $";

#include <module.h>
inherit "acauth_httpbasic";

// Module interface.

array register_module()
{
  return ({MODULE_SECURITY, "AC: HTTPS only authentication",
	   "Performs authentication with passwords using the HTTP "
	   "basic authentication scheme, but only allows SSL encrypted "
	   "connections.",
	   0, 1});
}

// Auth interface.

object(Identity) passive_auth (object(ProtPoint) pp, object req_id)
{
  if (!req_id->roxen_ssl_context)
    return 0;
  return ::passive_auth (pp, req_id);
}

mixed active_auth (object(ProtPoint) pp, object req_id, string realm, string msg)
{
  if (!req_id->roxen_ssl_context)
    return http_redirect( "https://" + req_id->request_headers->host
			  + req_id->not_query );
  return ::active_auth (pp, req_id, realm, msg);
}
