// Grubba's neat hack to add pike-modules to the Pike module path at
// compile time in the Roxen modules.

#if !constant (roxen)
// Stuff for using SiteBuilder outside Roxen.

// Make a directory hierachy
int mkdirhier(string from, int|void mode)
{
  int r = 1;
  string a, b;
  array f;

  f=(from/"/");
  b="";

  foreach(f[0..sizeof(f)-2], a)
  {
    r = mkdir(b+a);
#if constant(chmod)
    if (mode) {
      catch { chmod(b+a, mode); };
    }
#endif /* constant(chmod) */
    b+=a+"/";
  }
  if(!r)
    return (file_stat(from)||({0,0}))[1] == -2;
  return 1;
}
#endif

void create()
{
  string sbpath = combine_path (getcwd(), __FILE__ + "/../../..");

  string acpath = combine_path (sbpath, "modules/ac/aclib.pike");

  program aclibp =(program)acpath;

  if (!aclibp) {
    throw(({ sprintf("SiteBuilder: Cannot find the AC library (%O)\n", acpath),
	     backtrace() }));
  }

  object aclib = aclibp();
  add_constant ("PERM_N_A", aclib->PERM_N_A);
  add_constant ("PERM_NONE", aclib->PERM_NONE);
  add_constant ("PERM_READ", aclib->PERM_READ);
  add_constant ("PERM_WRITE", aclib->PERM_WRITE);

  master()->add_module_path (combine_path (sbpath, "pike-modules"));

  master()->putenv ("PATH", combine_path (sbpath, "bin")+
#ifdef __NT__
				 ";"
#else				 
				 ":"
#endif				 
		    +getenv ("PATH"));

#if !constant (roxen)
  add_constant ("report_error", werror);
  add_constant ("report_warning", werror);
  add_constant ("report_notice", werror);
  add_constant ("report_debug", werror);
  add_constant ("mkdirhier", mkdirhier);
#endif
}
