/*
 * $Id: sitebuilder_tags.pike,v 1.43 1999/08/15 21:22:50 wing Exp $
 *
 * Sitebuilder tags.
 *
 */

#include <config.h>
#include <module.h>

inherit "module";
inherit "roxenlib";

#if __VERSION__ < 0.6
import sb_addpath;
#else
import .sb_addpath;
#endif

import String;
import Array;
import Stdio;

#define DEBUG_MSG(a) (args->debug || id->misc->debug \
		      ? "<b>" + (a) + "</b>" \
		      : "")

#define CE_URL (ce_url || find_ce_url(id))
#define CE (ce || find_ce(id))
string ce_url;
object ce;
mapping (int:mapping) cache = ([ ]);

object find_ce( object id )
{
  array(object) ces =
    (column (roxen->configurations->modules, "content_editor") - ({0}))->enabled;
  foreach (ces, object c)
    if (c->site() == id->misc->wa->site)
      return ce = c;
}

string find_ce_url( object id )
{
  ce_url = CE->config->query( "MyWorldLocation" );
  if (ce->query( "location" )[0] == '/')
    ce_url += ce->query( "location" )[1..];
  else
    ce_url += ce->query( "location" );

  return ce_url;
}

string make_status_img( string loc, string rem, object id )
{
  if (loc == "none" && rem != "removed")
    // If the file doesn't have a local status, make a blank icon
    return CE_URL + "__sbinternal__img/empty.gif";
  else
    return CE_URL + "__sbinternal__img/" + loc + "_" + rem + ".gif";
}

mapping (string:string) get_metadata( object obj, object id )
{
  mapping md, res = ([ ]);
  object wa = id->misc->wa;
  object path = id->misc->localpath;
  array (string) arr;

  if (path == "index.html" || path[sizeof( path )-11..] == "/index.html")
    path = path[0..sizeof( path )-11];
  if (obj->isdir)
  {
    object index;

    if (obj->real_abspath( id ) == "")
    {
      res[ "url" ] = "/";
      res[ "content-editor" ] = CE_URL + "!" + wa->tag + "!/!files!0/";
    }
    else
    {
      res[ "url" ] = "/" + obj->real_abspath( id ) + "/";
      res[ "content-editor" ] = CE_URL + "!" + wa->tag + "!/"
	+ obj->real_abspath( id ) + "!!/!files!0/";
    }
    arr = path / "/";
    for (int c = 0; c < sizeof( arr ); c++)
      if (arr[..c] * "/" == obj->real_abspath( id ))
	res[ "selected" ] = "selected";
    index = wa->vcfile( obj->real_abspath( id ) + "/index.html", id );
    index = index && index->is_user_op( id, "metadata" );
    if (!index)
      res += ([ "notitlep" : 1,
		"title" : obj->name( id ) || "/",
		"type" : "dir",
		"type-img" : CE_URL + "__sbinternal__img/types/menu.gif",
      ]);
    else
    {
      // FIXME: Some sort of error handling when metadata isn't accessible?
      md = index->metadata( id )->md || ([]);
      res += ([ "title" : md->title || "",
		"keywords" : md->keywords || "",
		"description" : md->description || "",
		"type" : "directory",
		"type-img" : CE_URL + "__sbinternal__img/types/menu.gif",
		"language" : (md->language ? md->language : "none"),
		"status-img" : make_status_img( (index->userstat_ea( id )
						 || "none"),
						index->userstat_rep( id ),
						id ),
	        "filename" : "index.html",
	        "filesize" : (string )index->stat()[1],
		"template" : md->template,
      ]);
      sprintf( "index res: %O\n", res );
    }
  }
  else
  {
    res[ "url" ] = "/" + obj->real_abspath( id );
    res[ "content-editor" ] = CE_URL + "!" + wa->tag + "!/"
      + obj->real_abspath( id ) + "!files!0/";
    // FIXME: Some sort of error handling when metadata isn't accessible?
    md = obj->metadata( id )->md || ([]);
    res +=  ([ "title" : md->title || "",
	       "keywords" : md->keywords || "",
	       "description" : md->description || "",
	       "type" : md[ "http-content-type" ],
	       "type-img" : (CE_URL + "__sbinternal__img/types/"
			     + (wa->site->ct_data_for( obj )->img
				|| wa->site->ct_data_for("application"
							     "/octet-stream")
				->img)),
	       "status-img" : make_status_img( (obj->userstat_ea( id )
						|| "none"),
						obj->userstat_rep( id ),
					       id ),
	       "language" : (md->language ? md->language : "none"),
	       "filename": obj->real_name(),
	       "filesize" : (string )obj->stat()[1], 
	       "template" : md->template,
    ]);
    if (path == obj->real_abspath( id )
	|| id->misc->localpath == obj->real_abspath( id ))
      res[ "selected" ] = "selected";
  }
  res[ "permission" ] = obj->perm (id) == PERM_WRITE ? "write" : "read";
  res[ "workarea" ] = wa->name;
  res[ "workarea-id" ] = wa->tag;
  return res;
}

string base_dir( string path )
{
  array arr = path / "/";
  
  return (arr)[..sizeof( arr )-2] * "/";
}

string base_name( string path )
{
  return (path / "/")[-1];
}

static array (mapping) get_menu(string name, object id, void|int immediate)
{
  object wa = id->misc->wa;
  object menufile, handler;
  string path;
  array (string) arr;
  array (mapping) res, res2;
  string rel = "";
  int c;

  path = combine_path( base_dir( "/" + id->misc->localpath ), name );
  name = base_name( name );
  arr = ("/" + path) / "/";
  arr = arr[0..sizeof( arr ) -2];
  if (immediate)
    if (((menufile = wa->vcfile( arr * "/" + "/" + name, id )),
	 (menufile = menufile && menufile->is_user_op( id, "metadata" )))
	&& (handler = id->misc->sb->handler_for( menufile, id ))
	&& (handler->get_menu))
    {
      rel = arr * "/" + "/";
      res = handler->get_menu( menufile, id );
    }
    else
      return 0;
  else
    for (c=sizeof( arr )-1; c >= 0; c--)
      if (((menufile = wa->vcfile( arr[0..c] * "/" + "/" + name, id )),
	   (menufile = menufile && menufile->is_user_op( id, "metadata" )))
	  && (handler = id->misc->sb->handler_for( menufile, id ))
	  && (handler->get_menu))
	{
	  res = handler->get_menu( menufile, id );
	  rel = arr[0..c] * "/" + "/";
	  break;
	}
  if (!res)
    return 0;
  res2 = ({ });
  foreach (res, mapping m)
  {
    string path, title;
    object obj;
    mapping md;

    if (sscanf( m->url, "%*s://%*s" ) == 2)
    {
      res2 += ({ m });
      continue;
    }
    if (m->title && m->title != "")
      title = m->title;
    path = combine_path( rel, m->url );
    obj = wa->vcobj( path, id );
    obj = obj && obj->is_user_op( id, "metadata" );
    if (!obj)
      continue;
    md = get_metadata( obj, id );
    if (md)
      if (title)
	res2 += ({ md | ([ "title" : title, "notitlep" : 0 ]) });
      else
	res2 += ({ md });
  }
  return res2;
}

int check_globs( string filename, array (string ) globs )
{
  if (!globs || !filename)
    return 0;
  foreach (globs, string g)
  {
    while (strlen( g ) && g[0] == ' ')
      g = g[1..];
    while (strlen( g ) && g[-1] == ' ')
      g = g[0..strlen( g )-2];
    if (glob( g, filename ))
      return 1;
  }
  return 0;
}

static array (mapping) get_dir( int dirs, array (string) globs,
				array (string) content_types, object id,
				mapping args, void|string p )
{
  object wa = id->misc->wa;
  string path = (p ? combine_path( (id->misc->localpath / "/")
				   [0..sizeof( id->misc->localpath / "/" )-2]
				   * "/" + "/",
				   p )
		 : id->misc->localpath);
  string rel = "";
  multiset (mapping) res = (< >);
  array files;
  object dir = wa->vcdir( (path / "/")[0..sizeof( path / "/" )-2] * "/", id );
  array res2;

  dir = dir && dir->is_user_op( id, "metadata" );
  if (!dir)
    return 0;
  files = dir->list( id )->is_user_op( id, "metadata" ) - ({ 0 });
  if (p)
    if (p[0] == '/')
      rel = p;
    else
      rel = "/" + p;
  foreach (files, object obj)
    if (obj->isdirp())
      if (dirs)
	res[ get_metadata( obj, id ) ] = 1;
      else
	;
    else
    {
      if ((obj->name( id ) != "index.html" || args->index)
	  && (check_globs( obj->name( id ), globs )
	      || check_globs( obj->metadata( id )->md[ "http-content-type" ],
			      content_types )))
	res[ get_metadata( obj, id ) ] = 1;
    }
  res2 =  sort_array( indices( res ),
		     lambda (mapping a, mapping b)
		     {
		       return
			 b->type != a->type && b->type == "directory" ||
			 lower_case (b->title) < lower_case (a->title) ||
			 lower_case (b->title) == lower_case (a->title) && (
			   b->title < a->title ||
			   b->title == a->title && b->name < a->name);
		     } );
  return res2;
}

static array (mapping) get_history( object id, void|string p )
{
  object wa = id->misc->wa;
  string path = (p ? combine_path( (id->misc->localpath / "/")
				   [0..sizeof( id->misc->localpath / "/" )-2]
				   * "/" + "/",
				   p )
		 : id->misc->localpath);
  array arr = path / "";
  array (mapping) res = ({ });

  if (path == "")
    path = "/";
  else if (path[0] != '/')
    path = "/" + path;
  arr = path / "/";
  arr = arr[0..sizeof( arr )-2];
  for (int c = 0; c < sizeof( arr ); c++)
  {
    object dir = wa->vcdir( arr[0..c] * "/", id );

    dir = dir && dir->is_user_op( id, "metadata" );
    if (dir)
      res += ({ get_metadata( dir, id ) });
  }
  return res;
}
  
static void|string|array (mapping) get_output( mapping args, object id )
{
  array (mapping) res;
  object wa = id->misc->wa;
  int key = wa->mac->id_get_id( id );

  m_delete( id->misc, "sitebuilder_tags_sort" );
  if (!cache[ key ])
    cache[ key ] = ([ ]);
  if (!(id->pragma[ "no-cache" ] || args->nocache)
      && cache[ key ][ encode_value( args ) + id->misc->localpath ])
    return cache[ key ][ encode_value( args ) + id->misc->localpath ];
  if (args->menu)
  {
    if (args->path)
      args->menu = combine_path( args->path, args->menu );
    
    if (args->history)
      return "can't use the history attribute together with the menu "
	"attribute";
    else
      if (args->dirs || args->type || args->glob)
      {
	res = get_menu(	args->menu, id, 1 );
	if (!res)
	{
	  id->misc->sitebuilder_tags_sort = "title,filename";
	  res = get_dir( args->dirs && 1,
			 args->glob && args->glob / ",",
			 args->type && args->type / ",",
			 id, args,
			 args->path );
	}
      }
    else
      res = get_menu( args->menu, id );
  }
  else if (args->dirs || args->type || args->glob)
  {
    id->misc->sitebuilder_tags_sort = "title,filename";
    if (args->history)
      return "can't use the history attribute together with the dir, type "
	"or extension attribute";
    else
      res = get_dir( args->dirs && 1,
		     args->glob && args->glob / ",",
		     args->type && args->type / ",",
		     id, args,
		     args->path );
  }
  else if (args->history)
    res = get_history( id, args->path );
  else if (args->user)
  {
    object mac = wa->mac;
    mapping vars = ([]);
    
    if (mac->id_is_known( id ))
    {
      if (mappingp (mac->id_get_data( id )))
	// These are the user preferences set in the content editor.
	vars = mac->id_get_data( id );
      vars[ "user-id" ] = mac->id_get_id( id );
      vars[ "user-name" ] = mac->id_get_handle( id );
      vars[ "full-name" ] = mac->id_get_name( id );
      vars->type = mac->ID_TYPE_TEXTS[mac->id_get_type( id )];
      return ({ vars });
    }
    else
      return ({ ([ ]) });
  }
  else if (args->file == "file")
    res = ({ get_metadata( wa->vcobj( id->misc->localpath, id ), id )
	     - ([ "selected" : "selected" ]) });
  else if (args->file)
  {
    string f = "";

    if (args->path)
      f = args->path;
    else
      f = id->misc->localpath;
    f = (f / "/")[..sizeof( f / "/" )-2] * "/" + "/";
    f = combine_path( f, args->file );
    res = ({ get_metadata( wa->vcobj( f, id ), id )
	     - ([ "selected" : "selected" ]) });
  }
  if (res)
  {
    mapping max;
    int sel = -1;

    if (!args->notitle)
    {
      array res2 = ({ });

      foreach (res, mapping m)
	if (!m->notitlep && m->title && m->title != "")
	  res2 += ({ m });
      res = res2;
    }
    if (args->select)
      foreach (res, mapping m)
	if (m->filename == args->select || m->url == args->select)
	  m->selected = "selected";
	else
	  m_delete( m, "selected" );
    else
      for (int c; c < sizeof( res ); c++)
      {
	mapping m = res[c];
      
	if (m->selected)
	  if (max)
	    if (strlen( max->url ) > strlen( m->url ))
	      m_delete( m, "selected"  );
	    else
	    {
	      m_delete( max, "selected" );
	      max = m;
	      sel = c;
	    }
	  else
	  {
	    max = m;
	    sel = c;
	  }
      }
    if (args->above || args->below || args->selected)
    {
      array res2 = ({ });
      
      if (args->above)
	res2 += res[..sel-1];
      if (args->selected)
	res2 += res[sel..sel];
      if (args->below)
	res2 += res[sel+1..];
      res = res2;
    }
  }
  cache[ key ][ encode_value( args ) + id->misc->localpath ] = res;
  return res;
}

// get_menu( dir, menu, id )
// get_dir( dir, id )

string tag_sb_menu( string tag_name, mapping args, object id )
{
  mixed res;
  string result = "";

  if (!id->misc->wa)
    return DEBUG_MSG( "&lt;sb-menu&gt; can only be used within SiteBuilder" );
  res = get_output( args, id );
  if (!res)
    return DEBUG_MSG( "&lt;sb-menu&gt; couldn't find any menu " );
  else if (stringp( res ))
    return DEBUG_MSG( "&lt;sb-menu&gt; " + res );
  else
  {
    if (id->misc->sitebuilder_tags_sort)
    {
      args = ([ "sort" : id->misc->sitebuilder_tags_sort ]) + args;
      m_delete( id->misc, "sitebuilder_tags_sort" );
    }
    return do_output_tag( args + ([ "quote" : "#" ]),
			  res, 
			  "<mi href=\"#url:quote=http#\" "
			  "#selected#>"
			  "#title#</mi>\n", id );
  }
}

string tag_sb_output( string tag_name, mapping args, string contents,
		      object id )
{
  mixed res;
  string result;

  if (!id->misc->wa)
    return DEBUG_MSG( "&lt;sb-menu&gt; can only be used within SiteBuilder" );
  res = get_output( args, id );
  if (!res)
    return DEBUG_MSG( "&lt;sb-output&gt; couldn't find any contents" );
  else if (stringp( res ))
    return DEBUG_MSG( "&lt;sb-output&gt; " + res );
  else
  {
    if (id->misc->sitebuilder_tags_sort)
    {
      args = ([ "sort" : id->misc->sitebuilder_tags_sort ]) + args;
      m_delete( id->misc, "sitebuilder_tags_sort" );
    }
    return do_output_tag( args, res, contents, id );
  }
}

#define DO_LOGIC(a) ((!(a) == !(args->not)) ? "<false>" : contents + "<true>")

string tag_sb_if( string tag_name, mapping args, string contents, object id )
{
  object wa = id->misc->wa;
  
  if (args->ppoint)
  {
    if (wa->site->rxml_pp_exists( args->ppoint, id ))
    {
      int perm = wa->site->rxml_pp_try( args->ppoint, id );

      if (perm == PERM_NONE)
	return DO_LOGIC( args->none );
      else if (perm == PERM_READ)
	return DO_LOGIC( args->read );
      else if (perm == PERM_WRITE)
	return DO_LOGIC( args->write );
      return "<false>" + DEBUG_MSG( "&lt;sb-if&gt; Neither read, write nor "
				    "none attribute given." );
    }
    else
      return "<false>" + DEBUG_MSG( "&lt;sb-if&gt; No ppoint named '"
				    + args->ppoint + "'" );
  }
  return "<false>" + DEBUG_MSG( "&lt;sb-if&gt; No attributes given." );
}

string tag_sb_login( string tag_name, mapping args, string contents,
		     object id, object file, mapping defines )
{
  object mac = id->misc->wa->site && id->misc->wa->site->mac;
  if (!mac)
    return DEBUG_MSG ("SiteBuilder sb-login tag used without a site");
  return "<a href=\""+http_encode_string(id->not_query)+
    "?__sb_force_login="+mac->id_get_id(id)+"\">"+contents+"</a>";
}

int time_from_utc( string utc_time )
{
  int year, month, day, hour, min, sec;
  
  if (sscanf( utc_time, "%d/%d/%d %d:%d:%d", year, month, day, hour, min, sec )
      != 6)
    return 0;
  return mktime( sec, min, hour, day, month-1, year - 1900, 0, 0 );
}

string tag_sb_modified( string tag_name, mapping args, object id )
{
  string path = id->misc->localpath;
  object vcobj;
  if (args->file)
  {
    path = (path / "/")[..sizeof( path / "/" )-2] * "/" + "/";
    path = combine_path( path, args->file );
  }
  vcobj = id->misc->wa->vcobj( path, id );
  if (vcobj)
  {
    mapping|array(object(Sitebuilder.VCLogEntry)) log =
      vcobj->log( id, 0, 0, 0 );
    if (mappingp( log ) || !sizeof( log ))
      return "";
    if (args->when)
      return make_tag( "date", args
		       + ([ "unix_time"
			    : (string )time_from_utc( log[0]->date ) ]) );
    else if (args->by)
    {
      object mac = id->misc->wa->site && id->misc->wa->site->mac;

      if (!mac)
	return log[0]->user;
      if (mac->id_get_name( log[0]->user ))
	return mac->id_get_name( log[0]->user );
      else
	return log[0]->user;
    }
  }
  return "";
}

// Roxen glue

array register_module()
{
  return ({ MODULE_PARSER,
	   "SiteBuilder Tags Module",
	   "\
This modules contains tags to embed SiteBuilder functionality in your \
RXML pages.",
	   ({ }),
	   1 });
}

mapping query_tag_callers()
{
  return ([ "sb-menu" : tag_sb_menu,
	    "sb-modified" : tag_sb_modified,
  ]);
}

mapping query_container_callers()
{
  return ([ "sb-output" : tag_sb_output,
	    "sb-login" : tag_sb_login,
	    "sb-if" : tag_sb_if,
  ]);
}
