// Composite data returned by VCFile.view() and others.

mapping(string:mixed) md;
// The metadata. For VCFile.upload(), this is used for other things.

object(Stdio.File) fd;
// A file opened for reading after the metadata. For VCFile.upload(),
// this is a truncated file opened for writing after the metadata.

mapping|void upload_end (int failed)
// For VCFile.upload(), this should be called when the upload ends.
// The failed flag should be nonzero if there was an error; the
// uploaded file is then discarded, and the old local file (if any) is
// left intact. Returns an error of type "interrupted" if some other
// destructive operation was done on the VCFile object during the
// upload. No changes were made then.
{
  return md->vcfile->upload_end (this_object(), failed);
}

void create (mapping(string:mixed) _md, object(Stdio.File) _fd)
{
  md = _md, fd = _fd;
}
