//!
//! module vc
//! class versionedfile
//!	special parent class for cachefile
//!	that fetches a specific revision from CVS
//!	on demand rather than caching
//!

static private inherit "cachefile" : cachefile;

object file;

string data;
mapping the_metadata;

void create(object _file, string|void _revision, string|void _date)
{
  file = _file;
  data = file->update_stdout(_revision, _date);
  array x = separate_metadata(data);
  the_metadata = x[0];
  data = x[1];
}

void wake_up()
{
  // Uh?
}

array stat()
{
  int t = time(1);
  return ({0444, strlen(data), t, t, t, 0, 0});
}

mapping metadata()
{
  return the_metadata;
}

object openfile(string flags)
{
  return class {
    static string data;
    static int pos;
    void create(string _data) {
      data = _data;
      pos = 0;
    }
    array stat()
    {
      int t = time(1);
      return ({0444, strlen(data), t, t, t, 0, 0});
    }
    string read(int|void n)
    {
      if(!query_num_arg() || pos+n>strlen(data))
	n = strlen(data)-pos;
      string r = data[pos..pos+n-1];
      pos += n;
      return r;
    }
    int tell()
    {
      return pos;
    }
    int seek(int p)
    {
      int o = pos;
      if(p<0)
	p = strlen(data)+p;
      if(p<0)
	p = 0;
      else if(p>strlen(data))
	p = strlen(data);
      pos = p;
      return o;
    }
    int close (void|string how)
    {
      return 1;
    }
  }(data);
}

array(object|mapping) openfile_with_metadata(string flags)
{
  return ({ openfile(flags), the_metadata });
}

object openfile_temp_w(mapping|void new_metadata)
{
  throw(({"Foo!  Inexplicable stupidity detected.\n", backtrace()}));
}

string getfile()
{
  return data;
}

void update()
{
  // Uh?
}

object status()
{
  return file->status();
}
