inherit "../base.pike";

constant title = "Access Control";
constant group_order = ({ });
constant wizard_order = ({ });
constant order = 3;
constant backdoor_accessible = 1;

int visible (object id)
{
  object ac_module = id->misc->sb->get_ac_module();
  return ac_module && ac_module->acadm_root_perm (id);
}

#define STAG_QUOTE(arg) replace (arg, "'", "'\"'\"'")

constant default_sub = "Permissions";

string tag_access_control_interface (string name, mapping args, object id)
{
  object ac_module = id->misc->sb->get_ac_module();
  if (!ac_module)
    return "<h1><font color=red>Couldn't find the Access Control module</font></h1>\n\n"
      "<p>Please make sure the <em>Access Control</em> module "
      "is loaded in the virtual server running SiteBuilder.\n";

  if (!sizeof (id->misc->sub) && !id->query) {
    // Icky..
    id->misc->sub = default_sub;
    id->not_query += default_sub;
    array(string) split = id->raw_url / "?";
    id->raw_url = split[0] + default_sub + "?" + split[1..] * "?";
  }

  mixed res = ac_module->root_access (id) || ac_module->page_body (
    id, id->not_query[..sizeof (id->not_query) - sizeof (id->misc->sub) - 1]);

  if (mappingp (res)) {
    string s = res->data || "";
    if (res->error == 401) return "<h1>Access denied</h1>\n";
    if (res->error)
      s += "<return code=" + res->error +
	(res->rettext ? " text='" + STAG_QUOTE (res->rettext) + "'" : "") +
	">\n";
    if (res->extra_heads)
      foreach (indices (res->extra_heads), string header)
	s += "<header name='" + STAG_QUOTE (header) + "' value='" +
	  STAG_QUOTE (res->extra_heads[header]) + "'>\n";
    return s;
  }

  return res;
}
