// Create the select box for work areas, and redirect to a new url state when
// changed.

inherit "roxenlib";

import Sitebuilder;


string tag_change_selected_workarea(string tagname, mapping args, object id)
{
  if(id->variables->change_workarea) {
    // Find a path as close as possible to the current one in the new wa.
    array(string) path = ({});
    object(Workarea) wa = id->misc->sb->wa_lookup (id->variables->select_workarea);
    if (wa) {
      object vcobj;
      for (path = id->misc->path / "/";
	   sizeof (path) &&
	     (!(vcobj = wa->vcobj (path * "/", id)) || !vcobj->exists (id));
	   path = path[..sizeof (path) - 2]) {}
    }

    return
      "<redirect to='"+
      id->misc->build_url(id,0,0,path * "/",id->variables->select_workarea)+"'>";
  }
  return "";
}

string tag_select_workarea(string tagname, mapping args, object id)
{
  int selected = 0;
  string res="";
  array was=id->misc->sb->wa_list(id);
  if (args["write-only"])
    was = Array.filter (was, lambda (object(Workarea) wa, object id)
			       {return wa->access_perm (id) >= PERM_WRITE;}, id);
  if (!sizeof (was) || sizeof (was) == 1 && was[0]->tag == args->exclude)
    return "<em>None accessible</em>";
  sort(was->name,was);
  if (args->extra_value)
  {
    res += "<option value='" + args->extra_value + "'";
    if (args->selected == "__extra__")
      res += " selected>", selected = 1;
    else
      res += ">";
    res += html_encode_string( args->extra_name );
  }
  foreach(was, object wa)
  {
    if(wa->tag == args->exclude)
      continue;
    res += "<option value='"+wa->tag+"'";
    if((args->selected||id->misc->wa_tag)==wa->tag)
      res += " selected>", selected = 1;
    else
      res += ">";
    res += html_encode_string (wa->name);
  }
  if (!selected && args["show-unknown"])
    res = "<option value='' selected>(unknown)" + res;
  return "<select name=select_workarea>" + res + "</select>";
}

string container_login( string tag_name, mapping args, string contents,
			object id )
{
  object mac = id->misc->sb && id->misc->sb->mac;
  int myid = id->misc->backdoor? -17:mac->id_get_id(id);
  return "<a href=\""+http_encode_string(id->misc->build_url (id))+
    "?__sb_force_login="+myid+"\">"+contents+"</a>";
}

string tag_user( string tag_name, mapping args, object id )
{
  object mac = id->misc->sb && id->misc->sb->mac;
  return id->misc->backdoor ?
    "Using AC backdoor" + (mac ? " (user: " + mac->id_get_name (id) + ")" : "") :
    mac->id_get_name(id);
}
