inherit "_wizardbase";

constant name= "Edit//Download";
constant doc = "Download this file for editing";
constant operation = "download";

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

int button_enabled(object id, void|object vcobj)
{
  int up = ::button_enabled (id, vcobj);
  if (up <= 0) return up;

  return id->misc->sb->ct_data_for (vcobj, 0)->downloadp;
}

string page_0(object id, object(Sitebuilder.VCFile) vcfile)
{
  if (!vcfile || !vcfile->isfile) return 0;
  mapping|object vcfd=vcfile->download(id);
  if(objectp(vcfd)) {
    id->misc->sb_internal_file_name=vcfile->name(0, 0, 1);
    id->misc->sb_internal_file=vcfd;
  }
  else
    return html_error(Sitebuilder.error_msg(vcfd), id);
  return "";
}

int verify_0(object id)
{
  return 0;
}

string wizard_done(object id, object(Sitebuilder.VCFile) vcfile)
{
  return 0;
}


string|mapping parse_wizard_page(string form, object id, string wiz_name)
{
  // Even bigger kludge. No shit?
  object|string|mapping res=::parse_wizard_page(form, id, wiz_name);
  object vcfd = id->misc->sb_internal_file;
  if(vcfd) {
    mapping headers = ([]);
    foreach(indices(vcfd->md), string md) {
      if (md[..4] == "http-") {
	headers[md[5..]] = vcfd->md[md];
      }
    }

    object handler = id->misc->sb->handler_for(headers["content-type"]);
    res = handler->download (vcfd->fd, headers, id, vcfd->md, id->misc->vcobj);

    if(objectp(res)) {
      array st = res->stat();
      if (!st) {
	throw(({ "File disappeared\n", backtrace() }));
      } else if (st[1] < 0) {
	throw(({ sprintf("Unexpected file length: %d\n", st[1]),
		 backtrace() }));
      }
      int len = st[1] - res->tell();

      if (len < 0) {
	// Error
	throw(({ sprintf("Negative file length: %d\n", len), backtrace() }));
      }

      if (len > 0) {
	res = http_file_answer(res, "sitebuilder/download", len);
      } else {
	// Special case to avoid broken recalculation of the reply length.
	res = http_string_answer("", "sitebuilder/download");
      }
    } else if(stringp(res))
      res = http_string_answer(res, "sitebuilder/download");

    if (mappingp (res)) {
      if (!res->extra_heads) {
	m_delete(headers, "content-type");
	res->extra_heads = headers;
      }
      res->extra_heads["Content-Disposition"] =
	"inline; filename=\""+id->misc->sb_internal_file_name+"\";";
    }
  }

  return res;
}
