inherit "_wizardbase";

constant name= "Access Control//Remove protection point";
constant doc = ("Add a protection point");
constant operation = "remove_ppoint";

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

int button_enabled(object id, void|object vcobj)
{
  object ac_module = id->misc->sb->get_ac_module();
  if (!ac_module || ac_module->acadm_root_perm (id) < PERM_WRITE) return -1;
  return ::button_enabled (id, vcobj);
}

string page_0(object id, object(Sitebuilder.VCFile) vcobj)
{
  if(!vcobj) return 0;
  return
    "Press OK to remove the protection point for this "+
    (vcobj->isfile?"file.":"directory.");
}

string wizard_done(object id, object(Sitebuilder.VCFile) vcobj)
{
  if(!vcobj) return 0;

  mapping|void fault=vcobj->remove_ppoint(id);

  if(fault)
    return parse_wizard_page(html_error(Sitebuilder.error_msg(fault),
					id), id, "done");
  else
    return 0;
}
