// Undelete a file or directory.

// $Id: undelete.pike,v 1.6 1999/05/07 04:37:14 mast Exp $

inherit "_wizardbase";

constant name= "Undelete//Undelete";
constant doc = "Undelete a file or directory";
constant operation = "undelete";

import Sitebuilder;

#define ERRORMSG(text) \
  (text ? "<p><font color=darkred>" + text + "</font>\n" : "")


// Wizard callbacks.

string dispatch (object id, string page, object vcobj)
{
  if (button_enabled (id, vcobj) < 1) return "cancel";
  if (vcobj->isdir) {
    if (!id->variables->delete_msg || !sizeof (id->variables->delete_msg))
      return "start";
  }
  else if (page == "start") return "done"; // Never show start page for files.
  return page;
}

mapping(string:array) wizard_automaton = ([
  "start": ({			// Commit message when undeleting a dir.
    dispatch,
    0,
    0,
  }),

  "done": ({
    dispatch,
    0,
    0,
  }),
]);

string page_start (object id, object vcobj)
{
  return ERRORMSG (id->misc->wizard_error) +
    "\n<p>The directory /" + vcobj->real_abspath() +
    " is about to be undeleted.\n"
    "<p>Enter a log message:<br>\n"
    "<var name=delete_msg><br>\n"
    "Then press <b>Ok</b> to continue, or <b>Cancel</b> to abort.";
}

int verify_start (object id, object vcobj)
{
  if (!id->variables->delete_msg || !sizeof (id->variables->delete_msg)) {
    id->misc->wizard_error = "You must enter a log message.";
    return 1;
  }
  return 0;
}

string|mapping wizard_done (object id, object vcobj)
{
  mapping res = vcobj->isdir ?
    vcobj->undelete (id, id->variables->delete_msg) : vcobj->undelete (id);
  if (res) return html_error (error_msg (res), id);
}
