// $Id: upload_new_file.pike,v 1.7 1999/07/26 22:38:37 mast Exp $

inherit "_wizardbase";
constant name= "Edit//Upload new file";
constant doc = "Create and upload a new file";
constant operation = "newfile";

import Sitebuilder;

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

mapping(int:string) temp_files = ([]);

int button_enabled(object id, void|object vcobj)
{
  if(vcobj && !vcobj->isdir) return -1;
  return ::button_enabled (id, vcobj);
}

string page_0(object id, object(VCDir) vcdir)
{
  id->misc->wizard_title_path =
    vcdir->real_abspath() + "/" /*+ id->variables->filename*/;

  return ERROR + "<b>Upload " + html_encode_string (id->misc->path) + "</b>"
    "<p><b>Select local file:</b> <input type=file name=the_file>";
}

int verify_0( object id )
{
  if(!id->variables["the_file.filename"] || !id->variables->the_file ||
     !sizeof(id->variables["the_file.filename"]) ||
     !sizeof(id->variables->the_file))
  {
    error="No such file";
    return 1;
  }
  else
  {
    if(intp(id->variables->the_file))
      m_delete(temp_files,id->variables->the_file);
    
    int i;
    while(temp_files[i=random(0x7fffffff)]);
    temp_files[i]=id->variables->the_file;
    m_delete(id->variables,"the_file");
    id->variables->the_file=i;
  }
  error="";
}

string page_1(object id, object(VCDir) vcdir)
{
  if(!vcdir)
    return 0;

  return ERROR+"<b>Select filename:</b><br>"+
    replace("/"+html_encode_string(vcdir->abspath(id))+"/", "//", "/")+
    "<var name=filename type=string size=40 default=\""+
    (replace(id->variables["the_file.filename"],"\\","/")/"/")[-1] +"\">";
}

int verify_1(object id, object(VCDir) vcdir)
{
  if (!vcdir) return 0;

  if (!id->variables->filename || id->variables->filename=="") {
    error = "You must select a filename.";
    return 1;
  }

  if (search(id->variables->filename, "/")>=0) {
    error = "The filename must not contain slashes.  If you intend to create "
      "a file in a subdirectory, you need to do so from a view of that "
      "directory.";
    return 1;
  }

  if(!valid_name(id->variables->filename))
  {
    error = "Invalid characters in filename.";
    return 1;
  }

  mapping|object f = vcdir->descend(id, id->variables->filename, 0, 1);

  if (objectp(f))
  {
    // Slight security risk: A user with write access in a dir can
    // this way discover the names of files (s)he isn't allowed to
    // see.
    error = "There already exists a "+(f->isdir? "directory":"file")+
      " with the name "+html_encode_string(id->variables->filename)+
      " in this directory.  Please select a different name.";
    return 1;
  }
  id->variables["meta_http-content-type"]=
    id->misc->sb->find_content_type_from_filename(id->variables->filename);

  error = "";
}

string page_2(object id, object(VCDir) vcdir)
{
  if(!vcdir)
    return 0;

  id->misc->wizard_title_path =
    vcdir->real_abspath() + "/" + id->variables->filename;
  
  return ERROR+"Edit the metadata for the new file:<br><br>\n"
    "<sb-internal-metadata-editor _metavars=http-content-type "
    "'>\n";
}



string wizard_done(object id, object(VCDir) vcdir)
{
  mapping fault;
  array(string) metas = glob("meta_*", indices(id->variables));
  object(Sitebuilder.VCFile)|mapping newf =
    vcdir->newfile(id, id->variables->filename);

  id->misc->wizard_title_path =
    vcdir->real_abspath() + "/" + id->variables->filename;

  if(mappingp(newf))
    fault = newf;
  else
    fault = newf->set_metadata(id,
			       mkmapping(Array.map(metas, `[], 5, 0x7fffffff),
					 rows(id->variables, metas)));
  if(fault)
    return parse_wizard_page(html_error(error_msg (fault), id), id, "done");
  mapping|object vcfd=newf->upload(id);
  if(objectp(vcfd))
  {
    vcfd->fd->write(temp_files[id->variables->the_file]);
    m_delete(temp_files,id->variables->the_file);

    object handler = vcdir->wa->site->handler_for (newf, id);
    if (handler->upload (newf, id, vcfd)) vcfd->upload_end (0);
    else vcfd->upload_end(1);
  }
  else
  return parse_wizard_page(html_error(Sitebuilder.error_msg(vcfd),
				      id),
			   id, "done");
  return 0;

}


string parse_wizard_page(string form, object id, string wiz_name)
{
  // Big kludge. No shit?
  array(string) a = ::parse_wizard_page(form, id, wiz_name) / "method=get";
  return a[0] + "method=post enctype=multipart/form-data" + a[1..] * "method=get";
}
