inherit "../base.pike";

constant title = "Plugins";
constant order = 160;
constant group_order = ({ });
constant wizard_order = ({ });


string make_tablist(array(string) tabs, string current, object id)
{
  string res_tabs="";
  foreach(tabs, string tab)
  {
    mapping args = ([]);
    args->href = id->misc->build_url(id,tab+"/");
    if(current==tab)
    {
      args->selected = "selected";
      args->href="";
    }
    res_tabs += make_container( "tab", args, String.capitalize(tab));
  }
  return make_container("config_tablist",([]), res_tabs);
}

mapping detect_plugins(object id)
{
  array plugins=id->conf->get_providers("sitebuilder_plugin");
  plugins=Array.filter(plugins,lambda(object plugin, object id)
			       {
				 return
				   id->misc->sb->
				   plugin_pp_try(plugin->sb_plugin_name,id) >=
				   plugin->sb_minimal_access;
			       },id);
  return mkmapping(plugins->sb_plugin_name,plugins->sb_plugin_handle);
}


string plugintablist(object id, string current)
{
  array plugins=sort(indices(detect_plugins(id)));

  if(!sizeof(plugins))
    return "";
  else
    return make_tablist(plugins,current,id)+"<p>";
}

int visible(object id)
{
  return !!sizeof(detect_plugins(id));
}

string tag_plugins_tablist(string tagname, mapping args, object id)
{
  string plugin,s;
  sscanf(id->misc->sub,"%s/",plugin);
  return plugintablist(id,plugin);
}

#define STAG_QUOTE(arg) replace (arg, "'", "'\"'\"'")

string tag_show_plugin(string tagname, mapping args, object id)
{
  string newsub,plugin;
  mixed res="";
  if(sscanf(id->misc->sub,"%s/%s",plugin,newsub))
  {
    mapping plugins=detect_plugins(id);
    if(plugins[plugin]&&functionp(plugins[plugin]))
      res=plugins[plugin](newsub,id->misc->build_url(id,plugin+"/"),id,
			  id->misc->sb->plugin_pp_try(plugin,id));
    else
      res="No such plugin.";
  }
  // Terribly ugly hack to allow tags to return images etc.
  if(mappingp(res))
    id->misc->sb_result_mapping=res;
  else
    return res;
}


