inherit "wizard";
constant name= "RXML Protection Points//Change";
constant doc = ("Changes the name of an existing protection point");

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

int button_enabled(object id, void|object vcobj)
{
  return
    id->misc->sb->wa_admin_access(id) &
    !!sizeof(id->misc->sb->rxml_pp_list());
}

int|string page_0(object id, object(Sitebuilder.VCFile) vcfile)
{
  if (!sizeof( id->misc->sb->rxml_pp_list() ))
    return 1;
  return "Select which RXML protection point to change:"
    "<br><var type=select name=old options='"
    + id->misc->sb->rxml_pp_list() * ","
    + "'>";
}

int|string page_1(object id, object(Sitebuilder.VCFile) vcfile)
{
  if (!sizeof( id->misc->sb->rxml_pp_list() ))
    return 1;
  return "Select new name:"
    "<br><var size=20 name=new default='" + id->variables->old + "'>";
}

string wizard_done(object id, object(Sitebuilder.VCFile) vcfile)
{
  if (!sizeof( id->misc->sb->rxml_pp_list() ))
    return "There are no RXML protection points to change.";
  if (!id->misc->sb->rxml_pp_change( id->variables->old, id->variables->new,
				     id ))
    return "Could not change the RXML protection point " + id->variables->old
      + " to " + id->variables->new + ".";
  return 0;
}
