inherit "wizard";
constant name= "RXML Protection Points//Create";
constant doc = ("Create a new RXML protection point");

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

int button_enabled(object id, void|object vcobj)
{
  return id->misc->sb->wa_admin_access(id);
}

string page_0(object id, object(Sitebuilder.VCFile) vcfile)
{
  return "Select a name for the new RXML protection point:"
    "<var name=handle size=20>";
}

int verify_1(object id)
{
  if (id->misc->sb->rxml_pp_exists( id->handle, id ))
  {
    error = "There is already a RXML protection point named "
      + id->handle + ".";
    return 1;
  }
  return 0;
}

string wizard_done(object id, object(Sitebuilder.VCFile) vcfile)
{
  if (!id->misc->sb->rxml_pp_create( id->variables->handle, id ))
    return "Could not create a new RXML protection point.";
  return 0;
}
