inherit "wizard";
constant name= "Work areas//Create";
constant doc = ("Create a new work area");

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

int button_enabled(object id, void|object vcobj)
{
  return id->misc->sb->wa_admin_access(id) || -1;
}

string page_0(object id, object(Sitebuilder.VCFile) vcfile)
{
  return
    "Select the work area you want to branch from:<p>"
    "<sb-internal-select-workarea>";
}

string page_1(object id, object(Sitebuilder.VCFile) vcfile)
{
  string res=ERROR+
    "Enter a name for the new work area: "
    "<input type=string name=name>";
  return res;
}

int verify_1(object id)
{
  array was=id->misc->sb->wa_list(); // No id here; compare against all work areas.
  
  if(search(was->name,id->variables->name)!=-1)
  {
    error="That name is already used by another work area.";
    return 1;
  }
  if(!sizeof(id->variables->name))
  {
    error="You must enter a name for the new work area.";
    return 1;
  }
  return 0;
}

string wizard_done(object id, object(Sitebuilder.VCFile) vcfile)
{
  mapping settings=(["name":id->variables->name]);
  object from=id->misc->sb->wa_lookup(id->variables->select_workarea);
  if(!id->misc->sb->wa_new(settings,from,id))
    return "Could not create new work area.";
  return 0;
}
