inherit "wizard";
constant name= "Preferences//Editor profiles";
constant doc = ("Editor profiles");

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

int button_enabled(object id, void|object vcobj)
{
  return id->misc->sb->wa_admin_access(id);
}

string draw_editor( object id, mapping (string:array) editors, string editor,
		    mapping (string:mapping(string:string)) vars )
{
  string result = "";

  result +=
    "<h2>Anonymous access</h2>\n"
    "<table cellpadding=0 cellspacing=0>\n"
    "<tr><td>Enabled</td>"
    + (!vars->anonymous->enabled
       ? "<td><select name=anon_enabled>"
       "<option selected value=disabled>Disabled"
       "<option value=enabled>Enabled</select></td></tr>\n"
       : "<td><select name=anon_enabled><option  value=disabled>Disabled"
       "<option selected value=enabled>Enabled</select></td></tr>\n")
    + "<tr><td>Directory</td>"
    "<td><input size=50 name=anon_dir value='" + vars->anonymous->dir
    + "'></td></tr>\n"
    "<tr><td>SMB path</td>"
    "<td><input size=50 name=anon_smb_path value='" + vars->anonymous->smb
    + "'></td></tr>\n"
    "<tr><td>NFS path</td>"
    "<td><input size=50 name=anon_nfs_path value='" + vars->anonymous->nfs
    + "'></td></tr>\n"
    "<tr><td>AppleShare path </td>"
    "<td><input size=50 name=anon_appleshare_path value='"
    + vars->anonymous->appleshare + "'></td></tr>\n"
    "</table>\n"

    "<hr>\n<h2>Named access</h2>\n"
    "<table cellpadding=0 cellspacing=0>\n"
    "<tr><td>Enabled</td>"
    + (!vars->named->enabled
       ? "<td><select name=named_enabled>"
       "<option selected value=disabled>Disabled"
       "<option value=enabled>Enabled</select></td></tr>\n"
       : "<td><select name=named_enabled><option value=disabled>Disabled"
       "<option selected value=enabled>Enabled</select></td></tr>\n")
    + "<tr><td>Directory</td>"
    "<td><input size=50 name=named_dir value='" + vars->named->dir
    + "'></td></tr>\n"
    "<tr><td>SMB path</td>"
    "<td><input size=50 name=named_smb_path value='" + vars->named->smb
    + "'></td></tr>\n"
    "<tr><td>NFS path</td>"
    "<td><input size=50 name=named_nfs_path value='" + vars->named->nfs
    + "'></td></tr>\n"
    "<tr><td>AppleShare path </td>"
    "<td><input size=50 name=named_appleshare_path value='"
    + vars->named->appleshare + "'></td></tr>\n"
    "</table>\n";
  
  if (sizeof( editors ))
  {
    result += "<hr><p><table width=100% cellpadding=0 cellspacing=0>\n"
      "<tr><td width=100%><default value='" + editor + "'>"
      "<select name=select_editor>\n";
    foreach (sort( indices( editors ) ), string e)
      result += "<option>" + e + "\n";
    result += "</select>\n<input type=submit name=submit_select_editor "
      "value='Select Editor'>\n</td><td align=right>\n"
      "<input size=10 name=new_editor_name>&nbsp;"
      "<input type=submit name=submit_new_editor "
      "value='New Editor'>\n</td>\n</tr>\n</table>\n\n";
  }
  else
    result += "<input size=10 name=new_editor_name>&nbsp;"
      "<input type=submit name=submit_new_editor "
      "value='New Editor'>\n";

  if (editor)
  {
    result += "<table width=100% cellspacing=0 cellpadding=0>\n"
      "<tr><td width=100%><font size=+2><b>Editor "
      + editor + "</b></font></td>\n"
      "<td align=right><input type=submit name=submit_remove_editor "
      "value='Remove Editor'></td></tr>\n</table>\n"
      "<p><b>Valid for</b>\n"
      "<select name=editor_valid_for>"
      + (editors[ editor ]->valid == "anonymous"
	 ? "<option selected value=anonymous>Anonymous"
	 : "<option value=anonymous>Anonymous")
      + (editors[ editor ]->valid == "named"
	 ? "<option selected value=named>Named"
	 : "<option value=named>Named")
      + (editors[ editor ]->valid == "both"
	 ? "<option selected value=both>Anonymous and Named"
	 : "<option value=both>Anonymous and Named")
      + "</select>\n"
      "<p><b>Editor Definitions</b>";

    for (int c=0; c < sizeof( editors[ editor ]->defs ); c++)
    {
      result += "<hr>"
	"<p><b>Valid for content types</b>\n"
	"<br><input size=70 name=valid_content_types_" + c
	+ " value='"
	+ indices( editors[ editor ]->defs[c]->valid_content_types ) * ", "
	+ "'>\n"
	"<p><b>Output file content type</b>\n"
	"<br><input size=20 name=content_type_" + c + " value='"
	+ editors[ editor ]->defs[c]->content_type + "'>\n"
	"<p><b>Output file contents</b>\n"
	"<textarea cols=70 rows=10 name=contents_" + c + ">"
	+ html_encode_string( editors[ editor ]->defs[c]->contents )
	+ "</textarea>\n"
	+ "<p><input type=submit name=submit_remove_editor_definition_" + c
	+ " value='Remove Editor Definition'>\n";
    }

    result += "<hr>\n<p><input type=submit name=submit_new_editor_definition "
      "value='New Editor Definition'>";
  }
  return result;
}

void parse_variables( object id, mapping editors, mapping editor_vars )
{
  array submit_vars = glob( "submit_*", indices( id->variables ) );

  if (id->variables->editor)
  {
    array a = ({ });
    string valid_for = id->variables->editor_valid_for;
    
    for (int c; id->variables[ "valid_content_types_" + c ]; c++)
    {
      a += ({ ([ "valid" : id->variables[ "valid_" + c ],
		 "valid_content_types" :
		 mkmultiset( (id->variables[ "valid_content_types_" + c ]
			      - " ") / "," ),
		 "content_type" : id->variables[ "content_type_" + c ],
		 "contents" : id->variables[ "contents_" + c ] - "\r" ]) });
      m_delete( id->variables, "valid_content_types_" + c );
      m_delete( id->variables, "content_type_" + c );
      m_delete( id->variables, "contents_" + c );
    }
    editors[ id->variables->editor ] = ([ "valid" : valid_for,
					  "defs" : a ]);
  }
  if (sizeof( submit_vars ))
    switch (submit_vars[0])
    {
     case "submit_select_editor":
       id->variables->editor = id->variables->select_editor;
       break;

     case "submit_new_editor":
       id->variables->editor = id->variables->new_editor_name;
       editors[ id->variables->editor ] = ({ });
       break;
       
     case "submit_remove_editor":
       m_delete( editors, id->variables->editor );
       m_delete( id->variables, "editor" );
       break;
       
    case "submit_new_editor_definition":
       editors[ id->variables->editor ]->defs
	 += ({ ([ "valid_content_types" : "",
		  "content_type" : "",
		  "contents" : "" ]) });
       break;

     default:
       {
	 int c;
	 
	 sscanf( submit_vars[0], "submit_remove_editor_definition_%d", c );
	 editors[ id->variables->editor ]->defs =
	   editors[ id->variables->editor ]->defs[..c-1]
	   + editors[ id->variables->editor ]->defs[c+1..];
	 m_delete( id->variables, "submit_remove_editor_definition_" + c );
       }
    }
  if (!editor_vars->anonymous)
    editor_vars->anonymous = ([ ]);
  if (id->variables->anon_enabled)
    editor_vars->anonymous->enabled = id->variables->anon_enabled == "enabled";
  if (id->variables->anon_dir)
    editor_vars->anonymous->dir = id->variables->anon_dir;
  if (id->variables->anon_smb_path)
    editor_vars->anonymous->smb = id->variables->anon_smb_path;
  if (id->variables->anon_nfs_path)
    editor_vars->anonymous->nfs = id->variables->anon_nfs_path;
  if (id->variables->anon_appleshare_path)
    editor_vars->anonymous->appleshare = id->variables->anon_appleshare_path;

  if (!editor_vars->named)
    editor_vars->named = ([ ]);
  if (id->variables->named_enabled)
    editor_vars->named->enabled = id->variables->named_enabled == "enabled";
  if (id->variables->named_dir)
    editor_vars->named->dir = id->variables->named_dir;
  if (id->variables->named_smb_path)
    editor_vars->named->smb = id->variables->named_smb_path;
  if (id->variables->named_nfs_path)
    editor_vars->named->nfs = id->variables->named_nfs_path;
  if (id->variables->named_appleshare_path)
    editor_vars->named->appleshare = id->variables->named_appleshare_path;

  m_delete( id->variables, "anon_enabled" );
  m_delete( id->variables, "anon_dir" );
  m_delete( id->variables, "anon_smb_path" );
  m_delete( id->variables, "anon_nfs_path" );
  m_delete( id->variables, "anon_appleshare_path" );

  m_delete( id->variables, "named_enabled" );
  m_delete( id->variables, "named_dir" );
  m_delete( id->variables, "named_smb_path" );
  m_delete( id->variables, "named_nfs_path" );
  m_delete( id->variables, "named_appleshare_path" );

  m_delete( id->variables, "submit_select_editor" );
  m_delete( id->variables, "select_editor" );
  m_delete( id->variables, "submit_new_editor" );
  m_delete( id->variables, "new_editor_name" );
  m_delete( id->variables, "submit_remove_editor" );
  m_delete( id->variables, "submit_new_editor_definition" );
}

string page_0( object id )
{
  object content_editor = id->misc->content_editor;
  mapping editors;
  mapping editor_vars;

  if (id->variables->editors)
    editors = decode_value( id->variables->editors );
  else
    editors = id->misc->sb->get_editors();
  if (sizeof( editors ) && arrayp( values( editors )[0] ))
  {
    foreach( indices( editors ), string i)
      editors[ i ] = ([ "valid" : "anonymous",
			"defs" : editors[ i ] ]);
  }
  editor_vars = id->misc->sb->get_editor_vars();
  parse_variables( id, editors, editor_vars );
  id->variables->editors = encode_value( editors );
  id->variables->editor_vars = encode_value( editor_vars );
  if (!id->variables->editor && sizeof( editors ))
    id->variables->editor = sort( indices( editors ) )[0];
  return draw_editor( id, editors, id->variables->editor, editor_vars );
}

int verify_0( object id )
{
}

mapping wizard_done(object id)
{
  mapping editors, editor_vars;
  
  if (!id->misc->sb->wa_admin_access(id))
    return 0;

  if (id->variables->editors)
    editors = decode_value( id->variables->editors );
  else
    editors = id->misc->sb->get_editors();
  editor_vars = id->misc->sb->get_editor_vars();
  parse_variables( id, editors, editor_vars );
  id->misc->sb->set_editors( editors );
  id->misc->sb->set_editor_vars( editor_vars );
}

