inherit "wizard";
constant name= "Preferences//File types";
constant doc = ("Edit file types");

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

int button_enabled(object id, void|object vcobj)
{
  return id->misc->sb->wa_admin_access(id);
}

string folder(int num, int unfolded, object id)
{
  return "<input type=image name="+(unfolded?"fold":"unfold")+num+" src="+
    id->misc->img_url+
    (unfolded? "fold.gif":"unfold.gif")+" width=20 height=20  alt='"+
    (unfolded? "\/":"--")+"' border=0>";
}

array edit_content_type( string ct, mapping data, array handlers, int nr, array images, object id)
{
  return ({ folder(nr,1,id),
	    "\n<var type=string size=15 name=" + nr + "_content_type default='"
	    + ct + "'>\n",
	    "\n<var type=string size=10 name=" + nr + "_name default='"
	    + data->name + "'>\n",
	    "\n<var type=select name=" + nr + "_img choices='"
	    + sort(images) *","+"' default='"+data->img+"'>\n",
	    "\n<var type=select name=" + nr + "_handler default='"
	    + data->handler + "' choices='" + handlers * "," + "'>\n",
	    "\n<var type=select name=" + nr + "_downloadp default='"
	    + (data->downloadp ? "Yes" : "No") + "' choices='Yes,No'>\n",
	    "\n<var type=select name=" + nr + "_parsep default='"
	    + (data->parsep ? "Yes" : "No") + "' choices='Yes,No'>\n",
	    "\n<var type=string size=15 name=" + nr + "_extensions default='"
	    + sort( indices( data->extensions ) ) * ", " + "'>\n",
	    "\n<var type=string size=15 name=" + nr + "_default_file "
	    "default='" + (data->default_file ? data->default_file : "")
	    + "'>\n",
	    "\n<input type=submit name=" + nr + "_remove value=Remove>\n",
  });
}


string hidden(string name, string data)
{
  return " <input type=hidden name='"+name+"' value='"+data+"'>";
}

array view_content_type( string ct, mapping data, array handlers, int nr, string prefix, object id)
{
  return ({ folder(nr,0,id),
            ct+hidden(nr+"_content_type",ct),
	    data->name+hidden(nr+"_name",data->name),
	    "<img border=0 src=" + prefix + "types/"+ data->img + ">"
	    + hidden( nr + "_img", data->img ),
	    data->handler+hidden(nr+"_handler",data->handler),
	    (data->downloadp ? "Yes" : "No")+
	    hidden(nr+"_downloadp", (data->downloadp ? "Yes" : "No")),
	    (data->parsep ? "Yes" : "No")+
	    hidden(nr+"_parsep", (data->parsep ? "Yes" : "No")),
	    sort( indices( data->extensions ) ) * ", "+
	    hidden(nr+"_extensions",sort( indices( data->extensions ) )
		   * ", "),
	    (data->default_file
	     ? data->default_file + hidden( nr + "_default_file",
					    data->default_file )
	     : ""),
	    "" });
}


mapping parse_variables( object id )
{
  int c;
  mapping res = ([ ]);
  int unfoldp;
  for (c=0; id->variables[ c + "_content_type" ]; c++)
  {
    unfoldp=0;
    foreach( ({"","un"}), string gazonk)
      if(id->variables[gazonk+"fold"+c+".x"])
	unfoldp=(gazonk=="un");
    if (!id->variables[ c + "_remove" ])
      res[ id->variables[ c + "_content_type" ] ]
	= ([ "name" : id->variables[ c + "_name" ],
	     "handler" : id->variables[ c + "_handler" ],
	     "img" : id->variables[ c + "_img" ],
	     "downloadp" : id->variables[ c + "_downloadp" ] == "Yes",
	     "parsep" : id->variables[ c + "_parsep" ] == "Yes",
	     "unfoldp":unfoldp,
	     "extensions"
	     : mkmultiset( (id->variables[ c + "_extensions" ] - " ") / "," )
	])
	+ (id->variables[ c + "_default_file" ]
	   ? ([ "default_file" : id->variables[ c + "_default_file" ] ])
	   : ([ ]));
  }
  if (id->variables->new_row)
    res[ "" ] = ([ "name" : "",
		   "handler" : "default",
		   "img" : "unknown.gif",
		   "downloadp" : 1,
		   "parsep" : 0,
		   "extensions" : "" ]);
  return res;
}

void delete_variables( object id )
{
  int c;

  m_delete( id->variables, "new_row" );
  for (c=0; id->variables[ c + "_content_type" ]; c++)
  {
    m_delete( id->variables, c + "_remove" );
    m_delete( id->variables, c + "_content_type" );
    m_delete( id->variables, c + "_img" );
    m_delete( id->variables, c + "_name" );
    m_delete( id->variables, c + "_handler" );
    m_delete( id->variables, c + "_downloadp" );
    m_delete( id->variables, c + "_parsep" );
    m_delete( id->variables, c + "_extensions" );
    m_delete( id->variables, c + "_default_file" );
    m_delete( id->variables, "unfold"+c+".x");
    m_delete( id->variables, "unfold"+c+".y");
    m_delete( id->variables, "fold"+c+".x");
    m_delete( id->variables, "fold"+c+".y");
  }
}

string page_0( object id )
{
  object content_editor = id->misc->content_editor;
  mapping content_types = id->misc->sb->get_content_types();
  array (string) handlers = id->misc->sb->get_handlers();
  array res = ({ });
  int c;
  if (id->variables[ "0_content_type" ])
    content_types = parse_variables( id );
  delete_variables( id );
  foreach (sort( indices( content_types )), string i)
    if(content_types[i]->unfoldp)
      res += ({ edit_content_type(i, content_types[i], handlers, c++,
				  id->misc->ce->list_images(),id) });
    else
      res += ({ view_content_type( i, content_types[i], handlers, c++,
				   id->misc->img_url,id) });
  return ERROR+
    html_table( ({ "","Content Type", "Name", "Image", "Handler", "Download",
		     "Parse", "Extensions", "Default File", "Actions" }),res)+
    "<input type=submit name=new_row value='New row'";
}

int verify_0( object id )
{
}

mapping wizard_done(object id)
{
  if (!id->misc->sb->wa_admin_access(id))
    return 0;
 
//   werror( sprintf("%O",parse_variables(id)));
  id->misc->sb->set_content_types( parse_variables( id ) );
}

