inherit "wizard";
constant name= "Preferences//Languages";
constant doc = ("Languages");

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

int button_enabled(object id, void|object vcobj)
{
  return id->misc->sb->wa_admin_access(id);
}

string folder(int num, int unfolded, object id)
{
  return "<input type=image name="+(unfolded?"fold":"unfold")+num+" src="+
    id->misc->img_url+
    (unfolded? "fold.gif":"unfold.gif")+" width=20 height=20  alt='"+
    (unfolded? "\/":"--")+"' border=0>";
}


array edit_language( string extension, mapping data, int nr, object id )
{
  return ({ folder(nr,1,id),
	    (extension
	     ? ("\n<var type=string size=10 name=" + nr + "_extension "
		"default='" + extension + "'>\n")
	     : ("\n<input type=hidden name="+ nr + "_extension value=0>\n")),
	    "\n<var type=string size=15 name=" + nr + "_name default='"
	    + data->name + "'>\n",
	    "\n<var type=string size=15 name=" + nr + "_encoding default='"
	    + data->encoding + "'>\n",
	    (extension
	     ? "\n<input type=submit name=" + nr + "_remove value=Remove>\n"
	     : ""),
  });
}


string hidden(string name, string data)
{
  return " <input type=hidden name='"+name+"' value='"+data+"'>";
}

array view_language( string extension, mapping data, int nr, object id)
{
  return ({ folder(nr,0,id),
            (extension ? extension : "")
	    + hidden( nr + "_extension", extension ),
	    data->name + hidden( nr + "_name", data->name ),
	    data->encoding + hidden( nr + "_encoding", data->encoding ),
	    "" });
}


mapping parse_variables( object id )
{
  int c;
  mapping res = ([ ]);
  int unfoldp;
  for (c=0; id->variables[ c + "_extension" ]; c++)
  {
    unfoldp=0;
    foreach( ({"","un"}), string gazonk)
      if(id->variables[gazonk+"fold"+c+".x"])
	unfoldp=(gazonk=="un");
    if (!id->variables[ c + "_remove" ])
      res[ id->variables[ c + "_extension" ] == "0" ? 0
	   : id->variables[ c + "_extension" ] ]
	= ([ "name" : id->variables[ c + "_name" ],
	     "encoding" : id->variables[ c + "_encoding" ],
	     "unfoldp":unfoldp,
	]);
  }
  if (id->variables->new_row)
    res[ "" ] = ([ "name" : "",
		   "encoding" : "ISO-8859-1",
		   "unfoldp":1
    ]);
  return res;
}

void delete_variables( object id )
{
  int c;

  m_delete( id->variables, "new_row" );
  for (c=0; id->variables[ c + "_extension" ]; c++)
  {
    m_delete( id->variables, c + "_remove" );
    m_delete( id->variables, c + "_extension" );
    m_delete( id->variables, c + "_name" );
    m_delete( id->variables, c + "_encoding" );
    m_delete( id->variables, "unfold"+c+".x");
    m_delete( id->variables, "unfold"+c+".y");
    m_delete( id->variables, "fold"+c+".x");
    m_delete( id->variables, "fold"+c+".y");
  }
}

string page_0( object id )
{
  object content_editor = id->misc->content_editor;
  mapping languages = id->misc->sb->get_languages();
  array res = ({ });

  int c;
  if (id->variables->inited)
    languages = parse_variables( id );
  delete_variables( id );
  foreach (sort( indices( languages )), string i)
    if (languages[i]->unfoldp)
      res += ({ edit_language( i, languages[i], c++, id ) });
    else
      res += ({ view_language( i, languages[i], c++, id ) });
  return ERROR+
    html_table( ({ "","Code", "Name", "Encoding", "Actions" }),res)+
    "<input type=hidden name=inited value=1>"+
    "<input type=submit name=new_row value='New row'";
}

int verify_0( object id )
{
}

mapping wizard_done(object id)
{
  if (!id->misc->sb->wa_admin_access(id))
    return 0;

  mapping m=parse_variables(id);
  foreach(indices(m), string s)
    m_delete(m[s],"unfoldp");
  id->misc->sb->set_languages( m );
}

