inherit "wizard";
constant name= "Preferences//Local editors";
constant doc = ("Local editor configuration");

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

int button_enabled(object id, void|object vcobj)
{
  return id->misc->sb->wa_admin_access(id);
}

string draw_local_editors( object id, mapping editors, string editor )
{
  string res = "";

  if (!editor && sizeof( editors ))
    editor = sort( indices( editors ) )[0];
  res += "<input type=hidden name=current_editor value='" + editor
    + "'>\n";
  res += "<table cellspacing=0 cellpadding=0 width=100%>\n";
  res += "<tr><td width=100%>";
  if (editor)
  {
    res += "<select name=editor>\n";
    foreach (sort( indices( editors ) ), string e)
      if (e == editor)
	res += "<option selected>" + e + "\n";
      else	
	res += "<option>" + e + "\n";
    res += "</select>&nbsp;";
    res += "<input type=submit name=select_editor value='Select editor'>\n";
  }
  res += "</td>\n<td align=right>";
  res += "<input name=new_name size=10>&nbsp;";
  res += "<input type=submit name=new_editor value='New editor'>\n";
  res += "</td></tr></table>\n";
  if (editor)
  {
    res += "<textarea name=textarea rows=20 cols=60>";
    foreach (editors[ editor ], string r)
      res += (r / " ")[0] + "\t" + (r / " ")[1..] * " " + "\n";
    res += "</textarea>";
    res += "<p><input type=submit name=download value='Download editor'>";
  }
  return res;
}

array decode_variables( object id, mapping editors )
{
  string editor;
  array (string) v;

  if (id->variables->textarea)
  {
    v = ({ });
    foreach ((id->variables->textarea - "\r") / "\n", string l)
    {
      l = (replace( l, "\t", " " ) / " " - ({ "" })) * " ";
      if (sizeof( l / " " ) >= 2)
	v += ({ l });
    }
  }
  if (id->variables->current_editor)
    editors[ id->variables->current_editor ] = v;
  editor = id->variables->editor;
  if (id->variables->new_editor
      && !editors[ id->variables->new_editor ])
  {
    editor = id->variables->new_name;
    editors[ editor ] = ({ });
  }
  m_delete( id->variables, "editor" );
  m_delete( id->variables, "new_editor" );
  m_delete( id->variables, "new_name" );
  m_delete( id->variables, "textarea" );
  if (!id->variables->download)
    m_delete( id->variables, "current_editor" );
  return ({ editors, editor });
}

string page_0( object id  )
{
  mapping (string:array(string)) editors;
  string editor;

  editors = id->variables->editors;
  if (!editors)
    editors = id->misc->sb->get_local_editors();
  [editors, editor ] = decode_variables( id, editors );
  id->variables->editors = editors;
  if (id->variables->download)
    return 0;
  else
    return draw_local_editors( id, editors, editor );
}

mapping wizard_done( object id )
{
  if (id->variables->download)
  {
    string url = id->misc->img_url;
    string data = "REGEDIT4\r\n"
      "\r\n"
      "[HKEY_CURRENT_USER\\SOFTWARE\\Idonex\\Roxen Application Launcher\\1.0]"
      "\r\n"
      "\"config\"=\"";
    mapping response;
    
    foreach (id->variables->editors[ id->variables->current_editor ], string s)
      data += replace( s, ({ "\\", "\"" }), ({ "\\\\", "\\\"" }) ) + "\t";
    if (data[-1] == '\t')
      data = data[..strlen( data )-2];
    data += "\"\r\n\r\n";
    url = url[..sizeof(url)-5] + "regfile/editors.reg";
    url += "?regfile=";
    response = http_redirect( "/", id );
    response->extra_heads->Location += url[1..] + http_encode_url( data );
    return response;
  }

  id->variables->editors = decode_variables( id, id->variables->editors )[0];
  
  if (id->misc->sb->wa_admin_access( id ))
    id->misc->sb->set_local_editors( id->variables->editors );
}
