inherit "wizard";
constant name= "RXML Protection Points//Remove";
constant doc = ("Remove an existing protection point");

#define error id->misc->wizard_error
#define ERROR (error?"<font color=darkred>"+error+"</font><p>":"")

int button_enabled(object id, void|object vcobj)
{
  return
    id->misc->sb->wa_admin_access(id) &
    !!sizeof(id->misc->sb->rxml_pp_list());
}

int|string page_0(object id, object(Sitebuilder.VCFile) vcfile)
{
  if (!sizeof( id->misc->sb->rxml_pp_list() ))
    return 1;
  return "Select which RXML protection point to remove:"
    "<br><var type=select name=old options='"
    + id->misc->sb->rxml_pp_list() * ","
    + "'>";
}

string wizard_done(object id, object(Sitebuilder.VCFile) vcfile)
{
  if (!sizeof( id->misc->sb->rxml_pp_list() ))
    return "There are no RXML protection points to change.";
  if (!id->misc->sb->rxml_pp_remove( id->variables->old, id ))
    return "Could not remove the RXML protection point " + id->variables->old
      + ".";
  return 0;
}
