/*
 * $Id: sitebuilder_ftp.pike,v 1.1 1999/01/11 04:31:11 mast Exp $
 */

#include <module.h>

constant selected = 0;
constant name = "SiteBuilder FTP edit";
constant desc = "A virtual server for editing SiteBuilder files over FTP.";
constant modules = ({
  "ac_userdb#0",
  "workarea#0"
});

void enable(object config)
{
  foreach(modules, string module)
    config->enable_module(module);
}

void post(object node)
{
  object o, o2, o3;

  if (o = node->descend ("Global", 1)) {
    if (o2 = o->descend ("named_ftp", 1)) {
      o2->data[VAR_VALUE] = 1;
      o2->change (1);
    }
    else report_warning ("Couldn't turn on named FTP\n");
    if (o2 = o->descend ("anonymous_ftp", 1)) {
      o2->data[VAR_VALUE] = 0;
      o2->change (1);
    }
    else report_warning ("Couldn't turn off anonymous FTP\n");
    if (o2 = o->descend ("guest_ftp", 1)) {
      o2->data[VAR_VALUE] = 0;
      o2->change (1);
    }
    else report_warning ("Couldn't turn off FTP guest users\n");
    if (o2 = o->descend ("shells", 1)) {
      o2->data[VAR_VALUE] = "";
      o2->change (1);
    }
    else report_warning ("Couldn't deactivate shells database check\n");
    if (o2 = o->descend ("Ports", 1)) o2->folded = 0;
    o->save();
  }
  else report_warning ("Couldn't initialize in server variables section\n");

  if (o = node->descend("AC: User Database", 1)) {
    o->folded = 0;
    if (o2 = o->descend("ac_config", 1)) {
      o2->folded = 0;
      o2->change(1);
    }
  }
  else report_warning ("Couldn't find AC: User Database module\n");

  if (o = node->descend("SiteBuilder Work Area Filesystem", 1)) {
    o->folded = 0;
    if (o2 = o->descend ("0", 1)) {
      o2->folded = 0;
      if (o3 = o2->descend("download_mode", 1)) {
	o3->data[VAR_VALUE] = "All work areas";
	o3->change(1);
      }
      else report_warning ("Couldn't set download mode\n");
      if (o3 = o2->descend("location", 1)) {
	o3->folded = 0;
	o3->change(1);
      }
      if (o3 = o2->descend("sitebuilder", 1)) {
	o3->folded = 0;
	o3->change(1);
      }
    }
  }
  else report_warning ("Couldn't find SiteBuilder Work Area Filesystem module\n");
}
