/*
 * $Id: sitebuilder_view.pike,v 1.1 1999/01/11 04:31:12 mast Exp $
 */

#include <module.h>

constant selected = 0;
constant name = "SiteBuilder view area";
constant desc =
  "A virtual server for adding an additional view area to a SiteBuilder site.";
constant modules = ({
  "contenttypes#0",
  "ismap#0",
  "htmlparse#0",
  "directories#0",
  "graphic_text#0",
  "navigation#0",
  "sitebuilder_tags#0",
  "workarea#0",
  "weblayout#0",
});

void enable(object config)
{
  foreach(modules, string module)
    config->enable_module(module);
}

void post(object node)
{
  object o, o2, o3;

  if(o = node->descend( "Global", 1 )) {
    o->folded = 0;
    if(o2 = o->descend( "Ports", 1 )) {
      o2->folded = 0;
      o2->change(1);
    }
  }

  if (o = node->descend("SiteBuilder Work Area Filesystem", 1)) {
    o->folded = 0;
    if (o2 = o->descend ("0", 1)) {
      o2->folded = 0;
      if (o3 = o2->descend("location", 1)) {
	o3->folded = 0;
	o3->change(1);
      }
      if (o3 = o2->descend("workarea", 1)) {
	o3->folded = 0;
	o3->change(1);
      }
    }
  }
  else report_warning ("Couldn't find SiteBuilder Work Area Filesystem module\n");

  if (o = node->descend("WebLayout Templates", 1)) {
    if (o2 = o->descend("tmpl_storage_path", 1)) {
      o2->data[VAR_VALUE] = "/templates/";
      o2->change(1);
    }
    else report_warning ("Couldn't set weblayout template directory\n");
    if (o2 = o->descend("tmpl_storage_dir", 1)) {
      o2->data[VAR_VALUE] = "";
      o2->change(1);
    }
    else report_warning ("Couldn't turn off weblayout admin interface\n");
    o->save();
  }
  else report_warning ("Couldn't find SiteBuilder Work Area Filesystem module\n");
}
